//          Copyright Jean Pierre Cimalando 2018.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#pragma once

namespace Algorithms {

static const char16_t algorithm_0[] =
    u"┌┐\n"
    u"│1\n"
    u"└┤\n"
    u" 2\n"
    u" │\n"
    u" 3\n"
    u" │\n"
    u" 4";

static const char16_t algorithm_1[] =
    u"┌┐\n"
    u"│1 2\n"
    u"└┤ │\n"
    u" 3─┘\n"
    u" │\n"
    u" 4";

static const char16_t algorithm_2[] =
    u"┌┐\n"
    u"│1 2\n"
    u"└┤ │\n"
    u" ├─3\n"
    u" │\n"
    u" 4";

static const char16_t algorithm_3[] =
    u"┌┐\n"
    u"│1 3\n"
    u"└┤ │\n"
    u" 2 │\n"
    u" ├─┘\n"
    u" 4";

static const char16_t algorithm_4[] =
    u"┌┐\n"
    u"│1 3\n"
    u"└┤ │\n"
    u" 2 4\n"
    u" └─┘";

static const char16_t algorithm_5[] =
    u"┌┐\n"
    u"│1\n"
    u"└┼─┬─┐\n"
    u" 2 3 4\n"
    u" └─┴─┘";

static const char16_t algorithm_6[] =
    u"┌┐\n"
    u"│1\n"
    u"└┤\n"
    u" 2 3 4\n"
    u" └─┴─┘";

static const char16_t algorithm_7[] =
    u"┌┐\n"
    u"│1 2 3 4\n"
    u"└┴─┴─┴─┘";

}  // namespace Algorithms
